/************************* * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2003 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.     
************************** * * * * * * * * * * * * **************************/

#ifndef LOCALFILEPLUGIN_H
#define LOCALFILEPLUGIN_H

#include "plugins.h"

class QHaccTableIndex;

class LocalFileDBPlugin : public QHaccDBPlugin {
 public:
	LocalFileDBPlugin();
	virtual ~LocalFileDBPlugin();
	
	virtual bool save( const QString& home, bool protect, QString& error );
	virtual bool load( QHacc * engine, const QString& home, QString& error );
	virtual bool connect( QHacc * engine, const QString& home, QString& error );
	bool load( Table t, QHaccResultSet& model );
	virtual QString description() const;
	static QString sdescription();
	static void setPerms( const QString& home );

	uint cnt( Table t );

	int add( Table, const TableRow& );

	int updateWhere( Table, const TableSelect&, const TableUpdate& );
	int updateWhere( Table, const TableSelect&, const TableRow& );

	bool getWhere( Table, TableSelect *, uint size, QHaccResultSet *& results );
	bool getWhere( Table, const TableGet&, TableSelect *, uint size,
								 QHaccResultSet *& results );
	bool getWhere( Table, const TableSelect&, QHaccResultSet *& results );

	uint deleteWhere( Table, const TableSelect& );
	uint deleteWhere( Table, QHaccResultSet * );

	void indexOn( Table, int col, QHaccTableIndex *& );

	TableCol max( Table, int col );
	TableCol min( Table, int col );
	bool dirty() const;
	void startLoad( Table, uint =0 );
	void stopLoad( Table );

	virtual QString create( const QString& dirname ) const;
	static QString screate( const QString& dirname );
	virtual bool imprt( QHaccResultSet * );
	virtual bool exprt( QHaccResultSet * );

	virtual QString understands() const; // what QHACC_HOME keywords do I know?
	static QString sunderstands(); // what QHACC_HOME keywords do I know?

 protected:
	void init();

 private:
	QHaccTable ** dbs; // an array of all the tables
	QHaccTable * preferences, * accounts, * transactions;
	QHaccTable * accounttypes, * memtrans, * ledgers;
	bool needsave;

	QHaccTable * table( Table ) const; // lookup function
};

#endif
