/************************* * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2003 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.     
************************** * * * * * * * * * * * * **************************/

#ifndef _QHACCCONSTANTS_H
#define _QHACCCONSTANTS_H

#include <qstring.h>
#include <qdatetime.h>

enum ColType { CTNULL, CTSTRING, CTINT, CTUINT, CTFLOAT, CTBOOL, CTDATE };
enum Table { TRANSACTIONS, ACCOUNTS, PREFERENCES, ACCOUNTTYPES,
						 MEMORIZED, LEDGERS, ALL };

class QC {
 public:
	// trans constants
  static const int TID, TNUM, TPAYEE, TMEMO, TSUM, TDATE,	TRECO,
		TACCTID, TSPLITGROUP, TLID, TCOLS;
	static const char * TCOLNAMES[];
	static const ColType TCOLTYPES[];
	
	// account constants
	static const int AINSTNAME, AINSTADDR1, AINSTADDR2, AINSTCITY, AINSTSTATE,
    AINSTZIP, AINSTPHONE, AINSTFAX, AINSTEMAIL, AINSTCONTACT, AINSTNOTES,
		ANAME, ANUM, AOBAL, ACBAL, ATRANSNUMS, ADEFAULTNUM, ATAXED, ACATEGORY,
		ATYPE, APID, ACOLS, AID, ABUDGET, ARBAL;
	static const char * ACOLNAMES[];
	static const ColType ACOLTYPES[];
	static const char * ASEP;

	// preferences constants
	static const int PPREF, PVALUE, PCOLS;
	static const char * PCOLNAMES[];
	static const ColType PCOLTYPES[];

	// accounttype constants
	static const int YID, YNAME, YLP, YCOLS;
	static const char * YCOLNAMES[];
	static const ColType YCOLTYPES[];

	// ledger constants
  static const int LID, LNAME, LDESC, LCOLS;
	static const char * LCOLNAMES[];
	static const ColType LCOLTYPES[];

	// other values
	static const uint YREC, NREC, MREC;
	static const int TOTALS, MONTHLYB, MONTHLYD, JOURNAL, BUDGET, MBUDGET;
	static const int DECIMALS;
	static const int LINE, TWOLINE,	BAR, TWOBAR, PIE, AVES;
	static const int AMERICAN, EUROPEAN, YEARFIRST, NEVER, NEW, ALL;

	static const QDate XDATE;

	static const int NUMTABLES=6;
	static const char * TABLENAMES[];
	static const int TRANT, ACCTT, PREFT, ACTYT, MEMRT, LEDGT;

	static const char * ACCTINCRSTR;
};

#endif
