/************************* * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2003 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.     
************************** * * * * * * * * * * * * **************************/

#ifndef _QHACCMAINTENANCE_H
#define _QHACCMAINTENANCE_H

#include "qhacc.h"
#include "resultset.h"

#include <qfont.h>
#include <qstring.h>
#include <qdatetime.h>

/****************************************************************/
/** QHACC engine extensions                                    **/
/**                                                            **/
/**                                                            **/
/**                                                            **/
/**                                                            **/
/****************************************************************/

class QHaccExt{
 public:
	QHaccExt( QHacc * qhacc );
  ~QHaccExt();
	
	// command-line functions
	void archive( const char * );
	void restore( const char * );
	//void cron( const char * );
	bool exp( const char * );
	bool imp( const char * );
	bool reco( const char * );
	bool verify( bool andFix );

 private:
	QHacc * engine;

	//bool crondollars( QHaccTable * trans );
	void getMergedImpOf( QHaccIOPlugin * db, QHaccResultSet * rslt, bool reco );
	void mergeImport( Table t, QHaccTable& imported, uint * newids, 
										bool * dupls, int id, int check1, int check2 =-1,
										int check3 =-1, int check4 =-1 );
	static void sortImportIDs( uint * oldids, uint * newids, uint idsize );
	QString getLocalDirName() const;
};

#endif
