/************************** * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2003 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.     
*************************** * * * * * * * * * * * * **************************/

#ifndef _QHACCUTILS_H
#define _QHACCUTILS_H

#include "qhaccconstants.h"

#include <iostream>
using namespace std;

#include <qstring.h>
#include <qdatetime.h>

class Utils {
 public:
	~Utils();

	static Utils * get();
	static void parser( const QString& str, const QString& sep, int start,
											QString * tokens, int numT );
	static bool debug( int, std::ostream *& );
	static bool error( int, std::ostream *& );
	static void setDebug( int );
	static int getDebug();

	static const int PRINT, ERRFATAL, ERROPER, ERRDEFAULT, DBGMAJOR,
		DBGMINOR, CURIOSITY;

	static QString tcname( Table t, int field ); // return the field name
	static ColType tctype( Table t, int field ); // return the field type
	static int tcnum( Table t, const QString& name ); // return the field number
	static bool tcticks( Table t, int field ); // return if col need ticks in sql

	static QDate dateFromString( QString date, const QString& sep, int form );
	static QString stringFromDate( QDate date, const QString& sep, int form );

	
 private:
	static Utils * obj;
	static int QD;

	/* debug levels are:
	 *
	 * 0: no debugging nor errors
	 * 1: fatal errors only
	 * 2: errors that affect operation
	 * 3: errors requiring default values to be used
	 * 4: print major debugging information
	 * 5: print minor debugging information
	 * 6: for the curiosity cat
	 *
	 */
};

#endif
