/************************** * * * * * * * * * * * * ***************************
    Copyright (c) 1999-2003 Ryan Bobko
                       ryan@ostrich-emulators.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.     
*************************** * * * * * * * * * * * * **************************/

#ifndef _TABLEOPS_H
#define _TABLEOPS_H

#include "qhacctablerows.h"

class TableSelect {
 public:
	static const int EQ, NE, GT, GE, LT, LE, NO, ALL;

	TableSelect( int, const TableCol&, int checktype =TableSelect::EQ );
	TableSelect( const PosVal&, int checktype =TableSelect::EQ );
	TableSelect();
	TableSelect( const TableSelect& );
	const TableSelect& operator=( const TableSelect& );
	~TableSelect();

	void getAll( PosVal&, int& type ) const;
	bool check( const TableRow& ) const;
	QString toString() const;
	QString sqlSel() const;
	bool sqlValid() const;

 protected:
	int checktype;
	PosVal posval;
};

class TableUpdate {
 public:
	TableUpdate( int, const TableCol& );
	TableUpdate( PosVal * pvarr, uint pvarrsz );
	TableUpdate( const TableUpdate& );
	//const TableUpdate& operatior=( const TableUpdate& );
	~TableUpdate();

	const PosVal get( uint ) const;
	uint cnt() const;

 protected:
	uint arrsz;
	PosVal * changes;
};

class TableGet {
 public:
	TableGet();
	TableGet( int );
	TableGet( int, int modifier );
	TableGet( const int *, uint );
	~TableGet();
	
	uint cnt() const;
	int at( uint ) const;
	int getMod( uint ) const;

	static const int UQ;

 protected:
	int * positions;
	uint arrsz;
	int mod;
};

#endif
